.686
.model flat,stdcall 
option casemap:none 
.mmx
.xmm

include \masm32\include\windows.inc 
include \masm32\include\kernel32.inc 
include \masm32\include\user32.inc 
includelib \masm32\lib\kernel32.lib 
includelib \masm32\lib\user32.lib

.data
align 16
  actarr db   1,  3,  2,  3,  16,  6,  9, 48,  14,  8, 42, 27,  19, 15,  7, 40
         db  34, 30, 28, 22,  18, 12,  4,  0, 101,101,101,101, 101,101,101,101
         db 101,101,101,101, 101,101,101,101, 101,101,101,101, 101,101,101,101
         db 101,101,101,101,   1,  1,  1,  1,   1,  1,  1,  1,   1,  1,  1,  1

  maxarr db   5,  7, 11, 13,  17, 19, 23, 53,  29, 31, 59, 37,  41, 43, 47, 61
         db  67, 71, 73, 79,  83, 89, 97,101, 103,107,109,113, 127,131,137,139
         db 149,151,157,163, 167,173,179,181, 191,193,197,199, 211,223,227,229
         db 233,239,241,251,   6,  6,  6,  6,   6,  6,  6,  6,   6,  6,  6,  6

  plus24 db 16 dup(2)
  ones16 db 16 dup(1)
  xswap6 db 16 dup(6)
  hbit16 db 16 dup(128)  ;  hi bit for each byte, to compensate for signed byte comparison

 ;   zeroes dd 0         ;  edi used instead for speed
 ;   plus24 db 2,2,2,2   ;  ebx used instead
  anycnt dd 0         ;  6052595 for 16 bytes,  6979124 for 52 bytes, 10M iterations
  allcnt dd 0         ;  8805234 for 16 bytes, 11503055 for 52 bytes, 10M iterations

  times  dd 10000000  ;  ebx used instead
  szCap  db "MMX",0
  P      dd 0
  PID    dd 0

  CrTm   dd 0, 0
  ExTm   dd 0, 0
  KnTm   dd 0, 0   ; kernel time
  UsTm   dd 0, 0   ; user   time

  szFmt  db "%lu",13,10,"%lu",13,10,"%lu",13,10,"%lu",13,10,"%lu",0
  szMsg  db 256 dup (0)


.code
start:
   movq      mm1, qword ptr ones16    ; 1  16 1s   1
   movq      mm4, qword ptr plus24    ; 4  plus24  p24
   movq      mm6, qword ptr xswap6    ; 6  xswap6  6
   movq      mm2, qword ptr hbit16    ; 2  hbit16  h
;   movq      mm2, mm1
;   psllq     mm2, 7
                                      ; movq      mm6, qword ptr xswap6
                                      ;   mov ebx, dword ptr plus24     ; use ebx for plus24
alliters:
   movq      mm0, qword ptr actarr+0  ;
                                      ; movq      mm2, qword ptr actarr+8
                                      ;   mov eax, dword ptr actarr+0   ; get now for dword0
   xor edi, edi                       ; use edi for zeroes
   movq      mm3, qword ptr maxarr+0  ;
                                      ; movq      mm6, qword ptr maxarr+8
                                      ;   mov edx, dword ptr maxarr+0   ; get max for dword0
   xor ecx, ecx                       ; use ecx for index into the arrays

manybites:
   paddb     mm0,  mm4     ; a = a + p24         ; add the 2 or 4
                                      ; paddb     mm2,  mm4     ; a = a + p24     ; add the 2 or 4
                                      ;   add eax, ebx  ; add eax, plus24
spot:
; indented are new, to compensate for signed comparison
;   movq      mm5,  mm1     ; either mov 1, shl 7   or memory mov 128  aka hi bit
;   psllq     mm5,  7
;   movq      mm5,  qword ptr hbit16  
;   movq      mm0,  mm0
   movq      mm7,  mm3     ; t7 = m
    pxor      mm0,  mm2     ; t0 = t0 xor 128   flip hi bit
    pxor      mm7,  mm2     ; t7 = t7 xor 128   flip hi bit

   pcmpgtb   mm7,  mm0     ; if t7 > a then ff else 0
   pandn     mm7,  mm3     ; ff -> 0, 0 -> ff  AND m
   pxor      mm0,  mm2     ; flip hi bit back
   pxor      mm5,  mm5     ; t5 = 0
   psubb     mm0,  mm7     ; a = a - m

   pcmpeqb   mm5,  mm0     ; if t5 = a then ff else 0
   paddb     mm5,  mm1     ; t5 = t5 + 1  ( ff -> 0, 0 -> 1 )
   psadbw    mm5,  mm1     ; abs(t5 - 1)

   pextrw    esi,  mm5, 0  ; t = t5(0+1+2+3+4+5+6+7)
   add       edi,  esi     ; zeroes = zeroes + t

   movq      qword ptr [actarr+ecx*4],  mm0      ; save it/update memory
                                      ;   mov dword ptr [actarr+ecx*4], eax    
   inc ecx
   inc ecx
   cmp ecx, 14     ; 14 == 7 qwords,56 bytes  0..2..12.. when 14 done
   jz  @F
   movq      mm0,  qword ptr [actarr+ecx*4]      ; get next actarr qword
   movq      mm3,  qword ptr [maxarr+ecx*4]      ; get next maxarr qword
   jmp manybites
@@:
   cmp edi, 0      ; cmp zeroes, 0
   jz  @F
   inc anycnt      ; inc anycnt
   add allcnt, edi ; add allcnt, zeroes
@@:
;   pxor      mm4,  qword ptr [xswap6]   ; xor dword ptr plus24, 06060606h  switch 2 to 4 OR 4 to 2
   pxor      mm4,  mm6                  ; xor dword ptr plus24, 06060606h  switch 2 to 4 OR 4 to 2
   dec times
   jnz alliters
   movq      qword ptr plus24,  mm4

   invoke GetCurrentProcess
   mov P, eax
   invoke GetProcessTimes, P, addr CrTm, addr ExTm, addr KnTm, addr UsTm

   xor eax, eax
   xor edx, edx
   mov ecx, 52
@@:
   dec ecx
   movzx edx, [actarr+ecx]
   add eax, edx
   cmp ecx,  0
   jnz @B

   mov times, eax    ; reuse times to hold total of final byte values

   invoke wsprintf, addr szMsg, addr szFmt, anycnt, allcnt, KnTm+0, UsTm+0, times
   invoke MessageBox, NULL, addr szMsg, addr szCap, MB_OK
   invoke ExitProcess, NULL
end start